<?php
/**
 * @package    United Kingdom postcode handler for use with plg_hikashopshipping_bfextrafeatures.* @author     https://www.brainforge.co.uk
 * @copyright  (C) 2023 Jonathan Brain. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

defined('_JEXEC') or die;

use Brainforgeuk\Plugin\HikashopBFPostcodes\shippingunitedkingdom\Extension\shippingunitedkingdom;
use Joomla\CMS\Extension\PluginInterface;
use Joomla\CMS\Factory;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\DI\Container;
use Joomla\DI\ServiceProviderInterface;
use Joomla\Event\DispatcherInterface;

return new class () implements ServiceProviderInterface {
    /**
     * Registers the service provider with a DI container.
     *
     * @param   Container  $container  The DI container.
     *
     * @return  void
     *
     * @since   4.3.0
     */
    public function register(Container $container)
    {
        $container->set(
            PluginInterface::class,
            function (Container $container) {
                $plugin = new shippingunitedkingdom(
                    $container->get(DispatcherInterface::class),
                    (array) PluginHelper::getPlugin('hikashopbfpostcode', 'shippingunitedkingdom')
                );
                $plugin->setApplication(Factory::getApplication());

                return $plugin;
            }
        );
    }
};
