<?php
/**
 * @package    United Kingdom postcode handler for use with plg_hikashopshipping_bfextrafeatures.
 * @author     https://www.brainforge.co.uk
 * @copyright  (C) 2023 Jonathan Brain. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

namespace Brainforgeuk\Plugin\HikashopBFPostcodes\shippingunitedkingdom\Extension;

use Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Plugin\PostcodePlugin;
use Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Traits\ConfigurationTrait;
use Joomla\Event\DispatcherInterface;

\defined('_JEXEC') or die;

/**
 */
class shippingunitedkingdom extends PostcodePlugin
{
	use ConfigurationTrait;

	protected $postcodeType = ['UK' => 'PLG_HIKASHOPBFPOSTCODES_UNITEDKINGDOM_TITLE'];

	/*
	 */
	public function getShippingAddressPostcode($order)
	{
		$shippingAddressPostcode = parent::getShippingAddressPostcode($order);

		if (!empty($shippingAddressPostcode))
		{
			// AA9_9AA AA9A_9AA AA99_9AA
			switch ($len = strlen($shippingAddressPostcode))
			{
				case 5:
				case 6:
				case 7:
					if (!preg_match('/\A[A-Z]{1,2}[0-9]{1,2}[A-Z]{0,1}/', $shippingAddressPostcode))
					{
						break;
					}

					$end = substr($shippingAddressPostcode, $len - 3);
					if (!preg_match('/\A[0-9][A-Z][A-Z]\z/', $end))
					{
						break;
					}

					return substr($shippingAddressPostcode, 0, $len - 3) . '_' . $end;
				default:
					break;
			}
		}

		return '';
	}
}