<?php
/**
 * @package     Hikashop shipping plugin providing extra features
 * @version     0.0.1
 * @author      https://www.brainforge.co.uk
 * @copyright   Copyright 2023 Jonathan Brain. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Field;

defined('_JEXEC') or die('Restricted access');

use Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Plugin\OrderDeliveryDatePlugin;
use Joomla\CMS\Form\Field\RadioField;

class BfCollectionLockerModeField extends RadioField
{
	protected $type = 'bfcollectionlockermode';

    /*
     */
    protected function getOptions()
    {
	    $options = parent::getOptions();

        if (!empty($options) &&
            !OrderDeliveryDatePlugin::orderCollectionLockerFieldExists())
        {
            foreach($options as $value=>&$option)
            {
                if (intval($value))
                {
                    $option->disable = true;
                }
                else if (!$option->disable)
                {
	                $option->selected = true;
                }
            }
        }
        unset($option);

        return $options;
    }
}

