<?php
/**
 * @package     Hikashop shipping plugin providing extra features
 * @version     0.0.1
 * @author      https://www.brainforge.co.uk
 * @copyright   Copyright 2023 Jonathan Brain. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Field;

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

class BfExtraFeaturesHelpField extends FormField
{
	protected $type = 'bfextrafeatureshelp';

	/*
	 */
	public static function configHelp($element=null)
	{
		$lang = Factory::getApplication()->getLanguage();
		$locale = $lang->getLocale()[2];
		$base = URI::root();
		$text = '';
		$dir = dirname(__DIR__, 2) . '/help/';

		foreach (array(
							 'plg_hikashopshipping_bfextrafeatures.pdf',
						 ) as $help) {
			$file = $locale . '.' . $help;
			if (!file_exists($dir . $file))
			{
				$file = 'en-GB.' . $help;
				if (!file_exists($dir . $file))
				{
					continue;
				}
			}

			$text .= '<div style="height:3em;">';
			$text .= '<a id="' . $help . '" class="btn btn-primary" ' .
				'href="' . $base . 'plugins/hikashopshipping/bfextrafeatures/help/' .
					$file . '" ' . 'target="plg_hikashopshipping_bfextrafeatures-help" style="cursor:help;">';
			$text .= $help;
			$text .= '</a>';
			$text .= '</div>';
		}

		if (empty($text))
		{
			return Text::_('PLG_HIKASHOPSHIPPING_BFEXTRAFEATURES_HELP_NOTAVAILABLE');
		}

		return $text;
	}

	/*
	 */
	protected function getInput()
	{
		return self::configHelp();
	}
}

