<?php
/**
 * @package     Hikashop shipping plugin providing extra features
 * @version     0.0.1
 * @author      https://www.brainforge.co.uk
 * @copyright   Copyright 2023 Jonathan Brain. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Field;

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Form\Field\TextField;

class BfExtraFeaturesNumericField extends TextField
{
	protected $type = 'bfextrafeaturesnumeric';

    static protected $scriptLoaded = false;

	/*
	 */
	protected function getInput()
	{
		$html = parent::getInput();

		$html = str_replace('<input',
			'<input autocomplete="off" onkeypress="return bfextrafeatures.filterNumericInput(event, this);"',
			$html);

		return $html . $this->getScript();
	}

    /*
     */
    protected function getScript()
    {
        if (BfextrafeaturesnumericField::$scriptLoaded) return '';

	    BfextrafeaturesnumericField::$scriptLoaded = true;

	    ob_start();
	    ?>
        <script>
            var bfextrafeatures = bfextrafeatures || [];

            bfextrafeatures.filterNumericInput = function(e, el) {
                var chrTyped, chrCode=0, evt=e?e:event, result=false, newValue=el.value;

                chrCode = event.charCode;

                if (chrCode >= 48 && chrCode <= 57) {
                    return true;
                }

                evt.stopPropagation();
                return false;
            }
        </script>
	    <?php
	    return ob_get_clean();
    }
}

