<?php
/**
 * @package     Hikashop shipping plugin providing extra features
 * @version     0.0.1
 * @author      https://www.brainforge.co.uk
 * @copyright   Copyright 2023 Jonathan Brain. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Field;

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Form\Field\TextField;

class BfExtraFeaturesTimeField extends TextField
{
	protected $type = 'bfextrafeaturestime';

	static protected $scriptLoaded = false;
	/*
	 */
	protected function getInput()
	{
		$html = parent::getInput();

		$html = str_replace('<input',
            '<input autocomplete="off" onkeypress="return bfextrafeatures.filterTimeInput(event, this);"',
            $html);

		return $html . $this->getScript();
	}

	/*
	 */
	protected function getScript()
	{
		if (BfextrafeaturestimeField::$scriptLoaded) return '';

		BfextrafeaturestimeField::$scriptLoaded = true;

		ob_start();
		?>
        <script>
            var bfextrafeatures = bfextrafeatures || [];

            bfextrafeatures.filterTimeInput = function(e, el) {
                var chrTyped, chrCode=0, evt=e?e:event, result=false;

                if (el.value.length > 4) {
                    evt.stopPropagation();
                    return false;
                }

                chrCode = event.charCode;

                switch(el.selectionStart)
                {
                    case 0:
                        if (chrCode >= 48 && chrCode <= 50) {           // 0,1,2
                            return true;
                        }
                        break;
                    case 1:
                        switch(el.value.substr(0, 1))
                        {
                            case '2':
                                if (chrCode >= 48 && chrCode <= 51) {   // 0-3
                                    return true;
                                }
                                break;
                            default:
                                if (chrCode >= 48 && chrCode <= 57) {   // 0-9
                                    return true;
                                }
                                break;
                        }
                        break;
                    case 2:
                        if (chrCode == 58) {                            // :
                            return true;
                        }
                    case 3:
                        if (chrCode >= 48 && chrCode <= 53) {           // 0,1,2,3,4,5
                            return true;
                        }
                        break;
                    case 4:
                        if (chrCode >= 48 && chrCode <= 57) {   // 0-9
                            return true;
                        }
                        break;
                }

                evt.stopPropagation();
                return false;
            }
        </script>
		<?php
		return ob_get_clean();
	}
}

