<?php
/**
 * @package     Hikashop shipping plugin providing extra features
 * @version     0.0.1
 * @author      https://www.brainforge.co.uk
 * @copyright   Copyright 2023 Jonathan Brain. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Field;

defined('_JEXEC') or die('Restricted access');

use Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Plugin\PostcodePlugin;
use Joomla\CMS\Factory;
use Joomla\CMS\Form\Field\ListField;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\Event\Event;

class BfPostcodeFormatListField extends ListField
{
	protected $type = 'bfpostcodeformatlist';

    /*
     */
    protected function getOptions()
    {
	    $postcodeTypes = [];

		$eventData = array( &$postcodeTypes);
		PostcodePlugin::dispatchEvent('onHikashopBfPostcodeTypesLoad', $eventData);

		if (!empty($postcodeTypes))
		{
			foreach($postcodeTypes as &$postcodeTypeText)
			{
				$postcodeTypeText = Text::_($postcodeTypeText);
			}
			unset($postcodeTypeText);

			asort($postcodeTypes);

			foreach($postcodeTypes as $postcodeTypeCode=>$postcodeTypeText)
			{
				$this->addOption($postcodeTypeText, ['value' => $postcodeTypeCode]);
			}
		}

	    $options = parent::getOptions();

        return $options;
    }
}

