<?php
/**
 * @package    Hikashop shipping plugin providing extra features
 * @author     https://www.brainforge.co.uk
 * @copyright  (C) 2024 Jonathan Brain. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

namespace Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Helper;

use Joomla\CMS\Factory;

\defined('_JEXEC') or die('Restricted access');

abstract class DateHelper
{
	/*
     * @param   string $date YYYMMDD
     *
     * @return  Date object
	 */
	protected static $_date = [];
	public static function getDate($date='now')
	{
		if (!isset(self::$_date[$date]))
		{
			if ($date != 'now')
			{
				if (strlen($date) != 8) return null;

				$date = substr($date, 0, 4) . '-' .
					substr($date, 4, 2) . '-' .
					substr($date, 6, 2);
			}

			self::$_date[$date] = Factory::getDate($date, Factory::getApplication()->get('offset'));
		}

		return self::$_date[$date];
	}

	/*
	 */
	public static function getDeliveryDateInstance($itemDeliveryDate='now', $disable=false, $quantity=-1)
	{
		$instance = new \stdClass();

		$dateObj = DateHelper::getDate($itemDeliveryDate);
		$instance->dateObj = $dateObj;
		if (empty($dateObj))
		{
			$instance->weekday = null;
			$instance->afterOrderDay = 0;
		}
		else
		{
			$instance->weekday = $dateObj->format('w', true);
			$instance->afterOrderDay = intval($itemDeliveryDate) - intval(DateHelper::getDate()->format('Ymd', true));
		}

		$instance->quantity = $quantity;
		$instance->disable = $disable;
		$instance->value   = $itemDeliveryDate;

		return $instance;
	}
}
