<?php
/**
 * @package    Hikashop shipping plugin providing extra features
 * @author     https://www.brainforge.co.uk
 * @copyright  (C) 2024 Jonathan Brain. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

namespace Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Helper;

\defined('_JEXEC') or die('Restricted access');

abstract class FieldHelper
{
	const DELIVERYDATEFIELDTYPE = 'plg.bfdeliverydate';

	/*
	 */
	public static $_fields = [];
	public static function getField($table, $fieldType=FieldHelper::DELIVERYDATEFIELDTYPE)
	{
		$key = $table . '.' . $fieldType;
		if (!isset(self::$_fields[$key]) && !is_null(self::$_fields[$key] ?? ''))
		{
			$sql = 'SELECT *' .
				' FROM #__hikashop_field' .
				' WHERE field_type = ' . DatabaseHelper::quote($fieldType) .
				' AND field_table = ' . DatabaseHelper::quote($table) .
				' AND field_published = 1';
			$field = DatabaseHelper::loadObject($sql);
			if (empty($field)) return null;

			$field->field_options = unserialize($field->field_options);

			self::$_fields[$key] = $field;
		}


		return self::$_fields[$key];
	}
}
