<?php
/**
 * @package    Hikashop shipping plugin providing extra features
 * @author     https://www.brainforge.co.uk
 * @copyright  (C) 2023-2024 Jonathan Brain. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

namespace Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Plugin;

use Brainforgeuk\Plugin\HikashopShipping\BfExtraFeatures\Helper\FieldHelper;
use Joomla\CMS\Plugin\CMSPlugin;

\defined('_JEXEC') or die;

/**
 */
Class OrderDeliveryDatePlugin extends CMSPlugin
{
	static protected $deliveryDateFieldExists = null;
	static protected $collectionLockerFieldExists = null;

	/*
	 */
	public static function orderDeliveryDateFieldExists()
	{
		if (OrderDeliveryDatePlugin::$deliveryDateFieldExists === null)
		{
			$field = FieldHelper::getField('order');

			OrderDeliveryDatePlugin::$deliveryDateFieldExists = !empty($field);
		}

		return OrderDeliveryDatePlugin::$deliveryDateFieldExists;
	}

	/*
	 */
	public static function orderCollectionLockerFieldExists()
	{
		if (OrderDeliveryDatePlugin::$collectionLockerFieldExists === null)
		{
			$field = FieldHelper::getField('order');

			OrderDeliveryDatePlugin::$collectionLockerFieldExists = !empty($field);
		}

		return OrderDeliveryDatePlugin::$collectionLockerFieldExists;
	}
}